Debian Bug report logs - #306290
ITP: ttf-mph-2b-damase -- font with ranges from the latest version of unicode

version graph

Package: wnpp; Maintainer for wnpp is wnpp@debian.org;

Reported by: Paul Wise <pabs@debian.org>

Date: Mon, 25 Apr 2005 15:18:04 UTC

Owned by: Paul Wise <pabs3@bonedaddy.net>

Severity: wishlist

Fixed in version ttf-mph-2b-damase/001.000-3

Done: Paul Wise <pabs3@bonedaddy.net>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, debian-devel@lists.debian.org, <wnpp@debian.org>, paul wise <pabs@zip.to>:
Bug#306290; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Paul Wise <pabs@zip.to>:
New Bug report received and forwarded. Copy sent to debian-devel@lists.debian.org, <wnpp@debian.org>, paul wise <pabs@zip.to>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Paul Wise <pabs@zip.to>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: ITP: ttf-mph-2b-damase -- font with ranges from the latest version of unicode
Date: Mon, 25 Apr 2005 23:09:01 +0800
[Message part 1 (text/plain, inline)]
Package: wnpp
Severity: wishlist
Owner: Paul Wise <pabs@zip.to>

* Package name    : ttf-mph-2b-damase
  Version         : 001.000
  Upstream Author : Mark Williamson <node.ue@gmail.com>
* URL             : http://fixedsys.org/~node_ue/fonts/
* License         : Public Domain
  Description     : font with ranges from the latest version of unicode

MPH 2B Damase is a SuperUnicode font, including some ranges in Plane 1
and some ranges added only in the latest release of the Unicode
standard, 4.1 (such as Tifinagh, Kharosthi, hPhags-pa, Old Persian
Cuneiform etc).

Better short/long descriptions very welcome.

-- 
bye,
pabs
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, paul wise <pabs@zip.to>:
Bug#306290; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Paul Wise <pabs@zip.to>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, paul wise <pabs@zip.to>. Full text and rfc822 format available.

Message #10 received at 306290@bugs.debian.org (full text, mbox):

From: Paul Wise <pabs@zip.to>
To: debian-mentors@lists.debian.org
Cc: 306290@bugs.debian.org
Subject: RFS: ttf-mph-2b-damase -- font with ranges from the latest version of unicode
Date: Wed, 27 Apr 2005 02:11:53 +0800
[Message part 1 (text/plain, inline)]
Hi all,

(I'm not subscribed, please CC me and the ITP - MFT set)

Package name    : ttf-mph-2b-damase
Upstream Author : Mark Williamson <node.ue@gmail.com>
Upstream URL    : http://fixedsys.org/~node_ue/fonts/
License         : Public Domain
ITP             : http://bugs.debian.org/306290
Package         : deb-src http://mentors.debian.net/debian unstable main
http://mentors.debian.net/debian/pool/main/t/ttf-mph-2b-damase/
Description     : font with ranges from the latest version of unicode
MPH 2B Damase is a SuperUnicode font, including some ranges in Plane 1
and some ranges added only in the latest release of the Unicode
standard, 4.1 (such as Tifinagh, Kharosthi, hPhags-pa, Old Persian
Cuneiform etc).

Upstream has given blessings for this to be in debian. Better short/long
descriptions very welcome. Lintian/Linda clean.

-- 
bye,
pabs

http://pabs.zip.to
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, paul wise <pabs@zip.to>:
Bug#306290; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Stefan Baums <baums@u.washington.edu>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, paul wise <pabs@zip.to>. Full text and rfc822 format available.

Message #15 received at 306290@bugs.debian.org (full text, mbox):

From: Stefan Baums <baums@u.washington.edu>
To: 306290@bugs.debian.org
Cc: Andrew Glass <asg@u.washington.edu>, Mark Williamson <node.ue@gmail.com>
Subject: ITP: ttf-mph-2b-damase -- font with ranges from the latest version of unicode
Date: Sun, 8 May 2005 19:06:25 -0700
Please do not package this font as is.  It purports to cover the
Kharoṣṭhī block, but all the author did is copy the illustrative
glyphs from Unicode 4.1 into the corresponding encoding slots.
However, in common with the modern Indian scripts, a Kharoṣṭhī
font also needs contextual replacement mechanisms (e.g. via
OpenType) and a lot of additional composite glyphs to support the
script.  In the absence of these features, such a font with
pseudo‐support for a complex script X is liable to confuse
fontconfig and get in the way of other fonts that do in fact
support script X.  The more so if the font with pseudo‐support
_appears_ to be covering a wide range of scripts, like this one.
(This is also the biggest problem with the ‘Free UCS Outline
Fonts’, which contain the basic glyphs of, e.g., Devanagari, but
none of the required replacement mechanisms or composite glyphs.)

So I request that at a minimum, you remove the Kharoṣṭhī range
from this font unless and until it provides real and complete
support of the script.  That said, (some of) the other Plane 1
scripts that this font covers may work on a simple
character‐to‐glyph basis, and it would be a welcome addition to
have those available.  But please check which ones of them suffer
from insufficient support like Kharoṣṭhī (hPhags‐pa, for
instance).

My colleague Andrew Glass is the main author of the Kharoṣṭhī
Unicode encoding, and he is now working on a proper Kharoṣṭhī
font.  When that font is completed, we will make sure to submit it
for inclusion in Debian GNU/Linux.

And of course we are very pleased that people are interested in
support for Kharoṣṭhī.  It’s just a little bit more complicated
than putting those sixty‐odd glyphs in a font.  If you’d like to
develop a real Kharoṣṭhī font yourself, you are absolutely
welcome.  The description of contextual replacement mechanisms is
apparently not yet available from the Unicode website, but you
could check out our original encoding proposal at

   http://depts.washington.edu/ebmp/downloads/Kharoshthi.pdf

and work from there.

Best regards,
Stefan Baums

-- 
Stefan Baums
Asian Languages and Literature
University of Washington



Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, paul wise <pabs@zip.to>:
Bug#306290; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Stefan Baums <baums@u.washington.edu>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, paul wise <pabs@zip.to>. Full text and rfc822 format available.

Message #20 received at 306290@bugs.debian.org (full text, mbox):

From: Stefan Baums <baums@u.washington.edu>
To: 306290@bugs.debian.org
Cc: Andrew Glass <asg@u.washington.edu>, Mark Williamson <node.ue@gmail.com>
Subject: ITP: ttf-mph-2b-damase -- font with ranges from the latest version of unicode
Date: Sun, 8 May 2005 19:32:06 -0700
PS.  On closer inspection, it seems that the Kharoṣṭhī glyphs in
the Damase font are in fact not just copies from the Unicode
charts, but original designs.  Which is great!  I’d be interested
to hear (outside this bug report) what they were inspired by.

(The real problem of the font – no contextual substition and no
composite glyphs – remains.)

S.

-- 
Stefan Baums
Asian Languages and Literature
University of Washington



Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, paul wise <pabs@zip.to>:
Bug#306290; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Mark Williamson <node.ue@gmail.com>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, paul wise <pabs@zip.to>. Full text and rfc822 format available.

Message #25 received at 306290@bugs.debian.org (full text, mbox):

From: Mark Williamson <node.ue@gmail.com>
To: Stefan Baums <baums@u.washington.edu>
Cc: 306290@bugs.debian.org, Andrew Glass <asg@u.washington.edu>
Subject: Re: ITP: ttf-mph-2b-damase -- font with ranges from the latest version of unicode
Date: Mon, 9 May 2005 00:48:36 -0700
Hi Stefan,

You are correct.

However, I stand by my statement that it covers Kharoṣṭhī because it
does, in the same way that James Kass' Code2000 covers Burmese: it
includes the basic glyphs, but not the OpenType tables nessecary for
proper rendering of the script.

When I made the font, I had no information on Kharosthi halant forms
(or whatever they're called - I don't work in Indic scripts much), so
I left it with the silly glyph it has for a Kharosthi virama.

Is there an actual vowel-killer symbol in Kharosthi?

I have since come by information on the glyph shapes. I began to work
on incorporating it into my font, but gave up for a number of reasons:

1. Some of the glyphs I needed to draw from scratch, which takes a lot of time
2. The other ones, I would have to create composites manually, which
takes time but not as much.
3. I had intended for the current release of the font to be at least
somewhat stable
4. I am very bad with OpenType tables. Yes, I made them for MPH
Yangon, but I tried to make an Arabic font and, well, I totally fucked
it up. I am afraid to proceed to the creation of opentype tables for
my new experimental Syriac font. I might try copying them from an
existing font, but it would probably take a lot of work to adapt it.
It would be easier if I discarded ligatures, which is certainly an
option since ligatures are often wildly different in Nestorian and
Jacobite varieties.
5. I am lazy.
6. One of my main motivations for creating fonts is my political
philosophy. I believe that people being able to process text in their
indigenous language in some small way helps them move towards
self-determination. There is currently no population which uses
Kharosthi as its "native script". Only academics have a need to type
it, so I don't feel the same pressure. This isn't to say that I don't
care - I do - but rather that it is less of a priority for me and I
don't feel as bad putting it off as I did when I put off fixing the
Tifinagh codepoints.
7. I am lazy AND busy at the same time. I am currently sitting on my
bum, which I do most of the day. I read my e-mail alot and talk to
people over the internet alot. Other than that, I don't do a whole
lot, but when I do, I work on it very determinedly, and right now I'm
busy with a Sardinian-English dictionary.

In short, I may fix it someday. I do sincerely doubt that somebody
else won't produce a better Kharosthi font in the meantime, however.
In fact you are welcome, if you should so desire, to use my
glyphshapes to make a new font.

As for the inspiration for the glyphshapes: I interpolated the
outlines of a couple of different existing Kharosthi fonts, then
interpolated the result and my own drawings of the glyphs.

Mark

On 08/05/05, Stefan Baums <baums@u.washington.edu> wrote:
> PS.  On closer inspection, it seems that the Kharoṣṭhī glyphs in
> the Damase font are in fact not just copies from the Unicode
> charts, but original designs.  Which is great!  I'd be interested
> to hear (outside this bug report) what they were inspired by.
> 
> (The real problem of the font – no contextual substition and no
> composite glyphs – remains.)
> 
> S.
> 
> --
> Stefan Baums
> Asian Languages and Literature
> University of Washington
> 


-- 
SI HOC LEGERE SCIS NIMIVM ERVDITIONIS HABES
QVANTVM MATERIAE MATERIETVR MARMOTA MONAX SI MARMOTA MONAX MATERIAM
POSSIT MATERIARI
ESTNE VOLVMEN IN TOGA AN SOLVM TIBI LIBET ME VIDERE

Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, paul wise <pabs@zip.to>:
Bug#306290; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Andrew Glass <asg@u.washington.edu>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, paul wise <pabs@zip.to>. Full text and rfc822 format available.

Message #30 received at 306290@bugs.debian.org (full text, mbox):

From: Andrew Glass <asg@u.washington.edu>
To: Mark Williamson <node.ue@gmail.com>
Cc: Stefan Baums <baums@u.washington.edu>, <306290@bugs.debian.org>
Subject: Re: ITP: ttf-mph-2b-damase -- font with ranges from the latest version of unicode
Date: Mon, 9 May 2005 02:40:29 -0700 (PDT)
Dear Mark,

I was interested to see that you had taken the trouble to make a Kharosthi font. It is exciting to see that people have noticed that Kharosthi is now part of Unicode, and a complement to our efforts to have it included in the first place, Thank you!
As for the font, as Stefan has pointed out, and you are aware, Kharosthi is a complex font, and not surprisingly, you haven't made OpenType tables (yet). I made the font which is used in the Unicode tables - and have expermimented with various GSUB AND GPOS tables, but no software currently supports these tables, so the fact that the tables are lacking in your font is rather mute for the time being.

In answer to your question,

Is there an actual vowel-killer symbol in Kharosthi?

No, there is no explicit symbol in Kharosthi for halant, hence the control symbol. In the very few cases in where a halant-form of a sign is attested in the literature, it is formed by writing it as a subscript. When I create the OT tables for this character, I will map to a duplicate set of the base glyphs which are approximately 50% of full size and set lower on the writing line.

For further information about Kharosthi, please check the Unicode proposal, and my MA thesis.

http://depts.washington.edu/ebmp/downloads/Kharoshthi.pdf
http://depts.washington.edu/ebmp/downloads/Glass_2000.pdf

I am currently working on a revised version of my Gandhari Unicode font, once work on this is complete, I will finish adding OpenType tables to the Kharosthi font I have prepared. If you are interested, I will let you know when work on this is complete.

Best wishes and congratulations for producing the first Kharosthi Unicode font available on the internet.


Andrew Glass
Kyoto




Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, paul wise <pabs@zip.to>:
Bug#306290; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Paul Wise <pabs@zip.to>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, paul wise <pabs@zip.to>. Full text and rfc822 format available.

Message #35 received at 306290@bugs.debian.org (full text, mbox):

From: Paul Wise <pabs@zip.to>
To: 306290@bugs.debian.org, Stefan Baums <baums@u.washington.edu>
Cc: Mark Williamson <node.ue@gmail.com>, Andrew Glass <asg@u.washington.edu>
Subject: Re: Bug#306290: ITP: ttf-mph-2b-damase -- font with ranges from the latest version of unicode
Date: Mon, 09 May 2005 21:36:00 +0800
[Message part 1 (text/plain, inline)]
On Sun, 2005-05-08 at 19:06 -0700, Stefan Baums wrote:

> Please do not package this font as is.

It has already been packaged, no-one has sponsored the upload yet [1].

BTW, thanks go to the three of you for the interesting discussion on
fonts :)

I'm not very familiar with OpenType/fonts, or editing them, so I'd have
to defer any changes to Mark.

I initially wanted to package Mark's MPH Yangon Burmese Unicode font,
but it had problems with freetype rendering the characters wrongly (they
became widely spaced), so I deferred that packaging until these problems
can be resolved and so I did Damase in order to learn how to package
fonts in the meantime. The freetype developers are looking into it, but
they don't have much time. If either of you could help diagnose this,
that would be excellent.

My motivation for this was to support Burmese Unicode on Burma Indymedia
[2] and in free software in general. Mark tells me that Longhorn will
support Burmese, so it would be good to beat them to it. I note that
there is a burmese keyboard map in xkb, but no locale information for
glibc (and no working "free" fonts). Initially, we plan to support
Burmese and Karen using the Wwin_Burmese and KNU ASCII-based fonts with
a WYSIWYG editor called HTMLArea, and later write a script to convert
from these fonts to Unicode. We have an organising list at [3].

1. http://mentors.debian.net/debian/pool/main/t/ttf-mph-2b-damase/
2. http://burma.indymedia.org
   http://docs.indymedia.org/view/Local/ImcBurmaTech
3. http://lists.indymedia.org/imc-burma-tech

-- 
bye,
pabs
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, paul wise <pabs@zip.to>:
Bug#306290; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Stefan Baums <baums@u.washington.edu>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, paul wise <pabs@zip.to>. Full text and rfc822 format available.

Message #40 received at 306290@bugs.debian.org (full text, mbox):

From: Stefan Baums <baums@u.washington.edu>
To: Paul Wise <pabs@zip.to>
Cc: 306290@bugs.debian.org, Mark Williamson <node.ue@gmail.com>, Andrew Glass <asg@u.washington.edu>
Subject: Re: Bug#306290: ITP: ttf-mph-2b-damase -- font with ranges from the latest version of unicode
Date: Mon, 9 May 2005 13:51:18 -0700
Dear Paul and Mark,

> I'm not very familiar with OpenType/fonts, or editing them, so
> I'd have to defer any changes to Mark.

let me explain the problem a bit more.  In any program where you
don’t explicitly configure a separate font for every script under
the sun, which means pretty much anything but Mozilla, including
all GTK+ and Qt etc. programs, one main font is chosen (say,
Bitstream Vera Sans), and whenever the program encounters a
character (say Kharoṣṭhī) that is not covered by that main font,
it asks the fontconfig library to find a font that does contain
glyphs for that character, and then automatically gets them from
there.

The problem is that a) fontconfig does not know very much about
the capabilities of fonts apart from what glyphs there are in
there, and b) it prefers fonts with a broader script coverage
(thus determined) over those with a more narrow coverage.  That
means that on a system with

   – Mark’s Damase font (with glyphs for many scripts, but no
     OpenType mechanism for Kharoṣṭhī, Limbu, hPhags‐pa etc.),

and

   – a to‐be‐developed specialised Kharoṣṭhī font (with glyphs for
     only Kharoṣṭhī, but proper OpenType support)

fontconfig, when asked to provide for Kharoṣṭhī, will prefer the
Damase font over the specialised Kharoṣṭhī font, thus causing
broken rendering for Kharoṣṭhī text even though a font for proper
rendering would have been available.  (As far as Kharoṣṭhī is
concerned, this is a bit theoretic at this point, since the
specialised font does not exist yet, but may already affect Limbu
etc. users.)

This has been discussed on the fontconfig mailing list, and
somebody suggested that fontconfig should check for OpenType
support, but it’s not sure that that is going to happen.  At the
same time, the usefulness of a non‐OpenType Kharoṣṭhī (Limbu,
etc.) font for actual users (academic or native) is very limited,
since all one can do with it really is typeset an alphabet table,
but not any connected run of text.  That’s why I suggested that
removing Kharoṣṭhī, at least from the Debian package, may be the
best thing to do at this point, pending potential future
improvements in fontconfig that would mean that fonts with partial
support can no longer negatively impact fonts with full support on
the same system.

And of course this situation sucks, because it discourages
enthusiastic developers who want to get started somewhere, but
don’t have the time or resources to go all the way with
replacement tables and everything.  In our research project, at
the moment we also use non‐OpenType Kharoṣṭhī fonts, with just the
basic glyphs in the codepoints, and the composite glyphs in the
PUA, and everything has to be handpicked.  But that’s a
specialised internal use, and having a font distributed as part of
Debian is a different issue, especially if it impacts multiple
scripts.  Sorry if all that sounds a bit negative.

[I’ll send you some remarks on Burmese in a separate email,
outside this bug report.]

All best,
Stefan

-- 
Stefan Baums
Asian Languages and Literature
University of Washington



Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, paul wise <pabs@zip.to>:
Bug#306290; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Mark Williamson <node.ue@gmail.com>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, paul wise <pabs@zip.to>. Full text and rfc822 format available.

Message #45 received at 306290@bugs.debian.org (full text, mbox):

From: Mark Williamson <node.ue@gmail.com>
To: Stefan Baums <baums@u.washington.edu>
Cc: Paul Wise <pabs@zip.to>, 306290@bugs.debian.org, Andrew Glass <asg@u.washington.edu>
Subject: Re: Bug#306290: ITP: ttf-mph-2b-damase -- font with ranges from the latest version of unicode
Date: Mon, 9 May 2005 20:25:43 -0700
On 09/05/05, Stefan Baums <baums@u.washington.edu> wrote:
> Dear Paul and Mark,
> 
> > I'm not very familiar with OpenType/fonts, or editing them, so
> > I'd have to defer any changes to Mark.
> 
> let me explain the problem a bit more.  In any program where you
> don't explicitly configure a separate font for every script under
> the sun, which means pretty much anything but Mozilla, including
> all GTK+ and Qt etc. programs, one main font is chosen (say,
> Bitstream Vera Sans), and whenever the program encounters a
> character (say Kharoṣṭhī) that is not covered by that main font,
> it asks the fontconfig library to find a font that does contain
> glyphs for that character, and then automatically gets them from
> there.
> 
> The problem is that a) fontconfig does not know very much about
> the capabilities of fonts apart from what glyphs there are in
> there, and b) it prefers fonts with a broader script coverage
> (thus determined) over those with a more narrow coverage.  That
> means that on a system with
> 
>    – Mark's Damase font (with glyphs for many scripts, but no
>      OpenType mechanism for Kharoṣṭhī, Limbu, hPhags‐pa etc.),
> 
> and
> 
>    – a to‐be‐developed specialised Kharoṣṭhī font (with glyphs for
>      only Kharoṣṭhī, but proper OpenType support)
> 
> fontconfig, when asked to provide for Kharoṣṭhī, will prefer the
> Damase font over the specialised Kharoṣṭhī font, thus causing
> broken rendering for Kharoṣṭhī text even though a font for proper
> rendering would have been available.  (As far as Kharoṣṭhī is
> concerned, this is a bit theoretic at this point, since the
> specialised font does not exist yet, but may already affect Limbu
> etc. users.)

Limbu text isn't messed up in my font. True, there are no opentype
tables, but if you think that is actually as big a problem as it is
for Kharosthi, you are very wrong - I was actually /thanked/ by some
Limbu guy in Nepal for having the first Unicode font to support his
language, and on top of that he did not make any bug reports. From
what I know about Limbu, complex shaping requirements are minimal and
text can be read almost as easily without them.

As regards Kharosthi, although it may not display properly, I am
pretty sure that text in Kharosthi in my font is still readable,
although it definitely doesn't look good and is probably very
difficult and irritating to read.

I think it's similar to the way that many Chinese linguistics journals
write Mongolian script horizontally due to typographic limitations,
and nobody makes a big fuss.

In addition, if I did have the OT tables for Kharosthi, I don't
believe there is any support in _any_ OS for some of the complex
rendering nessecary for the language.

I'm also under the impression that the situation of hPhags-pa is
similar to that of Limbu, although I don't know much about the script.

> This has been discussed on the fontconfig mailing list, and
> somebody suggested that fontconfig should check for OpenType
> support, but it's not sure that that is going to happen.  At the
> same time, the usefulness of a non‐OpenType Kharoṣṭhī (Limbu,
> etc.) font for actual users (academic or native) is very limited,
> since all one can do with it really is typeset an alphabet table,
> but not any connected run of text.  That's why I suggested that
> removing Kharoṣṭhī, at least from the Debian package, may be the
> best thing to do at this point, pending potential future
> improvements in fontconfig that would mean that fonts with partial
> support can no longer negatively impact fonts with full support on
> the same system.

I highly disagree. If you are interested in publishing a newspaper in
the language, then you are indeed correct - it would not be
acceptable.

But if you are using it in a scholarly document otherwise writtten in
English, the Kharosthi should still be perfectly readable - it's in
the wrong direction, yes, it uses an ugly control symbol where there
should be conjunct consonants, yes, but for me at least English is
still readable when written backwards or upside down, and Arabic is
still readable when written using all isolated forms (although it is
irritating, after a while it becomes easier to read).

And regarding Limbu I must protest again: I'm pretty sure there are no
problems big enough with the current Limbu rendering that somebody
would not want to use it to print a newspaper.

> And of course this situation sucks, because it discourages
> enthusiastic developers who want to get started somewhere, but
> don't have the time or resources to go all the way with
> replacement tables and everything.  In our research project, at
> the moment we also use non‐OpenType Kharoṣṭhī fonts, with just the
> basic glyphs in the codepoints, and the composite glyphs in the
> PUA, and everything has to be handpicked.  But that's a
> specialised internal use, and having a font distributed as part of
> Debian is a different issue, especially if it impacts multiple
> scripts.  Sorry if all that sounds a bit negative.

"discourages enthusiastic developers who want to get started
somewhere" - if you really want, you are welcome to dismantle my font
and totally revamp it. I would like to know, but you don't have to
tell me, and you can even sell it for 300 bucks for a 1 computer
licence.

Are you saying that these enthusiastic developers would be less
discouraged if there were no Kharosthi support /at all/ in Debian? I
somehow doubt it - my font provides them with basic glyphshapes
already, which they would otherwise have to come up with on their own,
and all they have to come up with is opentype tables and a good name
for their font.

And I will repeat, this does _not_ impact multiple scripts.
 
> [I'll send you some remarks on Burmese in a separate email,
> outside this bug report.]

I am well aware of the shortcomings of my Burmese font, and I have
already told Paul Wise. It looks quite ugly in some situations, and
rendering isn't as good as I would've liked to make it. But it's
better than the rendering of Burmese by Code2000, and it doesn't have
to use font hacks like Myazedi.

Mark

Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, paul wise <pabs@zip.to>:
Bug#306290; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Stefan Baums <baums@u.washington.edu>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, paul wise <pabs@zip.to>. Full text and rfc822 format available.

Message #50 received at 306290@bugs.debian.org (full text, mbox):

From: Stefan Baums <baums@u.washington.edu>
To: Mark Williamson <node.ue@gmail.com>
Cc: Paul Wise <pabs@zip.to>, 306290@bugs.debian.org, Andrew Glass <asg@u.washington.edu>
Subject: Re: Bug#306290: ITP: ttf-mph-2b-damase -- font with ranges from the latest version of unicode
Date: Mon, 9 May 2005 21:18:00 -0700
> From what I know about Limbu, complex shaping requirements are
> minimal and text can be read almost as easily without them.

I am glad to hear that.

> As regards Kharosthi [...]  although it definitely doesn't look
> good and is probably very difficult and irritating to read.

Yes.

> I think it's similar to the way that many Chinese linguistics
> journals write Mongolian script horizontally due to typographic
> limitations,

No, the effect is greater.  This is not just about the writing
direction, but consonants and vowels won’t get connected
correctly.

> In addition, if I did have the OT tables for Kharosthi, I don't
> believe there is any support in _any_ OS for some of the complex
> rendering nessecary for the language.

That is correct.  A chicken‐and‐egg problem, since as long as
there isn’t a font, people won’t feel motivated to add the
rendering code either.  Though from what I hear on the Pango
development list, the Indic script code that they have is actually
fairly generic, and needs only minor tweaking for adding new Indic
fonts.  Then again, things may be complicated by the right‐to‐left
writing direction of Kharoṣṭhī.  That will be for the programmers
to sort out, which I am not, so I concentrate on the encoding and
font side.

> I'm also under the impression that the situation of hPhags-pa is
> similar to that of Limbu, although I don't know much about the
> script.

Neither do I, but here is a page

   http://www.ancientscripts.com/hphagspa.html

that says hPhags‐pa (like Tibetan, from which it is derived) uses
medial vowel signs (which aren’t illustrated on that page).  The
encoding of Tibetan (and therefore presumably hPhags‐pa) is
handled differently from the standard Indian model in Unicode.

> But if you are using it in a scholarly document otherwise
> writtten in English, the Kharosthi should still be perfectly
> readable

Here I disagree.  Yes, scholarly applications is what we are
interested in, and there rendering needs to be _accurate_.  At
least as much as in a hypothetical newspaper.

> - it's in the wrong direction, yes, it uses an ugly control
> symbol where there should be conjunct consonants,

For a scholarly publication, those are major and unacceptable
points right there.  Add to that the fact that vowels would not be
correctly connected with their bases.

Also, this is not just for palaeographic discussions with the
occasional letter in Kharoṣṭhī.  For that we would not have needed
an encoding the first places, but could just have inserted a few
images.  Rather, think of whole new applications that make actual
use of the computer‐encoded form of the Kharoṣṭhī material, like
comprehensive palaeographic databases.  Have a look at:

   http://www.indoskript.de/

> I somehow doubt it - my font provides them with basic
> glyphshapes already, which they would otherwise have to come up
> with on their own, and all they have to come up with is opentype
> tables and a good name for their font.

First and foremost, let me stress that your development of those
glyph shapes is _highly_ appreciated.  It really makes us happy to
see that people outside our small circle start getting interested
in the Kharoṣṭhī script, now that it is included in Unicode.

So now we have actually quite a number of glyph shapes in
different styles.  Not only yours, the letter illustrations that
Andrew uses throughout his MA thesis (that he sent you a link to)
are also outlines in TrueType format.  The next step forward will
now be to develop a set of OpenType rules, and maybe we can even
agree on common glyph naming schemes and such, so that we can
easily share those OpenType rules between our fonts and yours.
That would be great.

> And I will repeat, this does _not_ impact multiple scripts.

Even if none of the other scripts in your font need complex
rendering rules, there is still the fontconfig issue.  Definitely
not your fault, but fontconfig’s.  But since fontconfig is the
basis for font matching in Debian, and since this is about making
a package for Debian, the problem has to be addressed and worked
around until (hopefully) fontconfig becomes smart enough to look
beyond the glyphs and recognise which fonts also have combining
rules.

> I am well aware of the shortcomings of my Burmese font, and I
> have already told Paul Wise.

Actually, your Burmese font per se looks great, and many thanks
for producing that and making it available under the GPL!  The
spacing problem seems to lie on the side of the rendering engine,
and apparently, as Paul says, the Freetype people are looking into
it.

All best wishes,
Stefan

-- 
Stefan Baums
Asian Languages and Literature
University of Washington



Changed Bug submitter from Paul Wise <pabs@zip.to> to Paul Wise <pabs3@bonedaddy.net>. Request was from Paul Wise <pabs3@bonedaddy.net> to control@bugs.debian.org. Full text and rfc822 format available.

Owner changed from paul wise <pabs@zip.to> to Paul Wise <pabs3@bonedaddy.net>. Request was from Paul Wise <pabs3@bonedaddy.net> to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, Paul Wise <pabs3@bonedaddy.net>:
Bug#306290; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to 306290@bugs.debian.org, Stefan Baums <baums@u.washington.edu>, Andrew Glass <asg@u.washington.edu>, pabs3@bonedaddy.net:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, Paul Wise <pabs3@bonedaddy.net>. Full text and rfc822 format available.

Message #59 received at 306290@bugs.debian.org (full text, mbox):

From: Paul Wise <pabs3@bonedaddy.net>
To: Andrew Glass <asg@u.washington.edu>, Stefan Baums <baums@u.washington.edu>
Cc: 306290@bugs.debian.org
Subject: ttf-mph-2b-damase and fontconfig
Date: Tue, 19 Jul 2005 01:30:49 +0800
[Message part 1 (text/plain, inline)]
Hi,

I'm trying to get rid of cruft in my todo list, so...

About the fontconfig problem, would it help if I put a really low
priority in the defoma hints file? Currently it is at priority 20.

Or does fontconfig also have a hints file system that I could use?

Or would it be possible to modify the ttf so that fontconfig prefers
other fonts?

Another possibility might be to put something in the package description
about the limitations of the font with respect to Kharosthi and
Limbu/etc, and conflict with other fonts that are better than it for
certain parts of Unicode (when these enter debian). If either of you
could write a succinct, objective explanation of the problems as you see
them, I would be glad to include them, so this font could at least find
a larger audience. Perhaps a longer explanation could be put in a
README.Debian file included with the package.

Assuming I can find an appropriate workaround/fix for the above problem,
are either of you debian developers or could you suggest somewhere for
me to find a sponsor other than the normal debian-mentors list? Hmm,
perhaps debian-i18n or the freetype/fontconfig/defoma ppl would help.

-- 
bye,
pabs

http://qa.debian.org/developer.php?login=Paul+Wise&comaint=yes
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, Paul Wise <pabs3@bonedaddy.net>:
Bug#306290; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Stefan Baums <baums@u.washington.edu>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, Paul Wise <pabs3@bonedaddy.net>. Full text and rfc822 format available.

Message #64 received at 306290@bugs.debian.org (full text, mbox):

From: Stefan Baums <baums@u.washington.edu>
To: 306290@bugs.debian.org, Andrew Glass <asg@u.washington.edu>, pabs3@bonedaddy.net
Subject: Re: ttf-mph-2b-damase and fontconfig
Date: Fri, 22 Jul 2005 19:28:16 -0700
Hi Paul,

first of all, I recently bought a new laptop and switched to
Ubuntu after Debian miserably failed to install on that computer.
So I cannot any longer perform any testing on Debian itself.

Now for your questions:

> About the fontconfig problem, would it help if I put a really
> low priority in the defoma hints file? Currently it is at
> priority 20.

I never really understood what defoma was good for.  My impression
was that fontconfig does not care at all what is configured in
defoma, but that impression may very well be wrong.  The
fontconfig package (at least Ubuntu’s) does contain some files
that have ‘defoma’ in their name.

> Or does fontconfig also have a hints file system that I could
> use?

Fontconfig has at least three places to configure preferences:

   /etc/fonts/fonts.conf
   /etc/fonts/local.conf
   ~/.fonts.conf

The individual settings in these three files are somehow merged in
some order of preference, presumably with the per-user settings
given most weight.  Please do

   man 5 fonts-conf

to learn more about the file format.  Note that fontconfig tends
to make it difficult to mark specific fonts as (dis)preferred
since its very purpose is to make manual configuration
unnecessary.  Fontconfig has a website and mailing list archive at

   http://www.fontconfig.org/wiki/

In the latter you can read more about how various people
nonetheless managed to (dis)prefer specific fonts.  I don’t
remember the details.

> Or would it be possible to modify the ttf so that fontconfig
> prefers other fonts?

All I can think of is removing the insufficiently supported
scripts (Kharoṣṭhī, Limbu, etc.) entirely.  But as the author of
the font pointed out previously, he would not like this, and there
may be a certain very limited usefulness of incomplete script
support in the case of those scripts where a proper font does not
yet exist.

> Another possibility might be to put something in the package
> description about the limitations of the font with respect to
> Kharosthi and Limbu/etc, and conflict with other fonts that are
> better than it for certain parts of Unicode (when these enter
> debian).

As I said, a proper Kharoṣṭhī font does not yet exist.  I don’t
know about Limbu etc.

> If either of you could write a succinct, objective explanation
> of the problems as you see them, I would be glad to include
> them, so this font could at least find a larger
> audience. Perhaps a longer explanation could be put in a
> README.Debian file included with the package.

I don’t really know what I could add to my description of the
problem in earlier posts in this bug report discussion, plus I am
very busy with other work now.  Could you maybe try to write
something up based on our earlier discussion?  I’ll be happy to
look it over and add anything important that seems to be missing.

> Assuming I can find an appropriate workaround/fix for the above
> problem, are either of you debian developers or could you
> suggest somewhere for me to find a sponsor other than the normal
> debian-mentors list?

No, neither one of us is a Debian developer, and I don’t know
where you could find a sponsor.  And as a I said, at this point my
interest has become rather indirect, inasmuch as the Debian
package concerned may or may not trickle down into Ubuntu, the
distribution that I switched to.

Cheers,
Stefan

-- 
Stefan Baums
Asian Languages and Literature
University of Washington



Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>:
Bug#306290; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Paul Wise <pabs3@bonedaddy.net>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>. Full text and rfc822 format available.

Message #69 received at 306290@bugs.debian.org (full text, mbox):

From: Paul Wise <pabs3@bonedaddy.net>
To: Stefan Baums <baums@u.washington.edu>
Cc: 306290@bugs.debian.org, Andrew Glass <asg@u.washington.edu>
Subject: Re: ttf-mph-2b-damase and fontconfig
Date: Sat, 23 Jul 2005 13:03:54 +0800
[Message part 1 (text/plain, inline)]
On Fri, 2005-07-22 at 19:28 -0700, Stefan Baums wrote:

> first of all, I recently bought a new laptop and switched to
> Ubuntu after Debian miserably failed to install on that computer.

Interesting - debian and ubuntu installers are the same program, did you
file an installation report?

I'll investigate options for font-config and try to write a better
package description and some stuff for README.Debian. I might try the
debian-i18n lists for sponsorship. Thanks for the info.

-- 
bye,
pabs

http://qa.debian.org/developer.php?login=Paul+Wise&comaint=yes
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>:
Bug#306290; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to Paul Wise <pabs3@bonedaddy.net>:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>. Full text and rfc822 format available.

Message #74 received at 306290@bugs.debian.org (full text, mbox):

From: Paul Wise <pabs3@bonedaddy.net>
To: Stefan Baums <baums@u.washington.edu>
Cc: 306290@bugs.debian.org, Andrew Glass <asg@u.washington.edu>
Subject: Re: ttf-mph-2b-damase and fontconfig
Date: Sat, 23 Jul 2005 15:00:44 +0800
[Message part 1 (text/plain, inline)]
On Fri, 2005-07-22 at 22:17 -0700, Stefan Baums wrote:

> Thanks for looking into the font problem.  Don’t spend too much
> time on it, though, maybe a note in the package description and a
> short README file is enough.

I added the following to the description and added the attached extract
of the earlier discussion with Mark to the README.Debian file.

 The support for some fonts is not complete because the font lacks
 contextual substition (via OpenType tables) and composite glyphs,
 which are required to support Kharosthi and other scripts fully. Please
 read the Debian README for a fuller discussion of the problems this
 may cause.

> I’d feel stronger about this if we already had a full Kharoṣṭhī font
> as an alternative for Damase, but we aren’t quite there yet.

Let me know when this is available and I'll do the debian packaging if
necessary.

I'll now try to look for a sponsor for the package. If I can find
anything to fix fontconfig, I'll add that too, but I don't feel that it
is urgent until there is a better alternative to Damase.

-- 
bye,
pabs

http://qa.debian.org/developer.php?login=Paul+Wise&comaint=yes
[README.Debian (text/x-readme, attachment)]
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, <wnpp@debian.org>, Paul Wise <pabs3@bonedaddy.net>:
Bug#306290; Package wnpp. Full text and rfc822 format available.

Acknowledgement sent to 306290@bugs.debian.org, debian-mentors@lists.debian.org, pabs3@bonedaddy.net:
Extra info received and forwarded to list. Copy sent to <wnpp@debian.org>, Paul Wise <pabs3@bonedaddy.net>. Full text and rfc822 format available.

Message #79 received at 306290@bugs.debian.org (full text, mbox):

From: Paul Wise <pabs3@bonedaddy.net>
To: debian-i18n@lists.debian.org, debian-mentors@lists.debian.org
Cc: 306290@bugs.debian.org
Subject: RFS: ttf-mph-2b-damase -- font with ranges from the latest version of unicode
Date: Sun, 24 Jul 2005 13:11:42 +0800
[Message part 1 (text/plain, inline)]
Hi all,

(I'm not subscribed, please CC me and the ITP - MFT set)

Package name    : ttf-mph-2b-damase
Upstream Author : Mark Williamson <node.ue@gmail.com>
Upstream URL    : http://fixedsys.org/~node_ue/fonts/
License         : Public Domain
ITP             : http://bugs.debian.org/306290
Package         : deb-src http://mentors.debian.net/debian unstable main
http://mentors.debian.net/debian/pool/main/t/ttf-mph-2b-damase/
Description     : font with ranges from the latest version of unicode
 MPH 2B Damase is a SuperUnicode font, including ranges in Plane 1 and
 ranges added in the latest release of the Unicode standard (4.1). Some
 of these ranges include Tifinagh, Kharosthi, hPhags-pa, Old Persian
 Cuneiform and Limbu etc.

 The support for some scripts is not complete because the font lacks
 contextual substition (via OpenType tables) and composite glyphs, which
 are required to support Kharosthi, Limbu and other scripts fully. Please
 read the Debian README for a fuller discussion of the problems this
 may cause.

Upstream has given blessings for this to be in debian. Better short/long
descriptions very welcome. Lintian/Linda clean. I hope to find a
workaround for the fontconfig problem mentioned in README.Debian (and
discussed in the ITP), but my initial quick scan of the docs and wiki
hasn't yielded anything. Any suggestions are welcome :)

-- 
bye,
pabs

http://qa.debian.org/developer.php?login=Paul+Wise&comaint=yes
[signature.asc (application/pgp-signature, inline)]

Reply sent to Paul Wise <pabs3@bonedaddy.net>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Paul Wise <pabs3@bonedaddy.net>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #84 received at 306290-close@bugs.debian.org (full text, mbox):

From: Paul Wise <pabs3@bonedaddy.net>
To: 306290-close@bugs.debian.org
Subject: Bug#306290: fixed in ttf-mph-2b-damase 001.000-3
Date: Sun, 28 Aug 2005 14:49:53 -0700
Source: ttf-mph-2b-damase
Source-Version: 001.000-3

We believe that the bug you reported is fixed in the latest version of
ttf-mph-2b-damase, which is due to be installed in the Debian FTP archive:

ttf-mph-2b-damase_001.000-3.diff.gz
  to pool/main/t/ttf-mph-2b-damase/ttf-mph-2b-damase_001.000-3.diff.gz
ttf-mph-2b-damase_001.000-3.dsc
  to pool/main/t/ttf-mph-2b-damase/ttf-mph-2b-damase_001.000-3.dsc
ttf-mph-2b-damase_001.000-3_all.deb
  to pool/main/t/ttf-mph-2b-damase/ttf-mph-2b-damase_001.000-3_all.deb
ttf-mph-2b-damase_001.000.orig.tar.gz
  to pool/main/t/ttf-mph-2b-damase/ttf-mph-2b-damase_001.000.orig.tar.gz



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 306290@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Paul Wise <pabs3@bonedaddy.net> (supplier of updated ttf-mph-2b-damase package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.7
Date: Mon, 15 Aug 2005 19:43:34 +0800
Source: ttf-mph-2b-damase
Binary: ttf-mph-2b-damase
Architecture: source all
Version: 001.000-3
Distribution: unstable
Urgency: low
Maintainer: Paul Wise <pabs3@bonedaddy.net>
Changed-By: Paul Wise <pabs3@bonedaddy.net>
Description: 
 ttf-mph-2b-damase - font with ranges from the latest version of unicode
Closes: 306290
Changes: 
 ttf-mph-2b-damase (001.000-3) unstable; urgency=low
 .
   * Build-depend on defoma for dh_installdefoma
 .
 ttf-mph-2b-damase (001.000-2) unstable; urgency=low
 .
   * Update description, TODO.Debian and README.Debian about the problems
   with fontconfig, Damase and specialised fonts.
   * Move dh_install params to debian/install
   * Update standards version (no changes needed)
   * Update maintainer email address
 .
 ttf-mph-2b-damase (001.000-1) unstable; urgency=low
 .
   * Initial Release (Closes: #306290).
Files: 
 8701334d48a71b57cd08edc7ec0bd501 619 x11 optional ttf-mph-2b-damase_001.000-3.dsc
 f602775d297bb3dd0950504de205f683 495033 x11 optional ttf-mph-2b-damase_001.000.orig.tar.gz
 a42ecb33b60042df7b57e52b7c56772f 2229 x11 optional ttf-mph-2b-damase_001.000-3.diff.gz
 bde7e11ae42f5bee80c7a1166f72ab5a 496712 x11 optional ttf-mph-2b-damase_001.000-3_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.1 (GNU/Linux)

iD8DBQFDDahw97LBwbNFvdMRAszHAJ0YTPVn/THjBkma+Rx+wDvzq934zgCfUjhF
2NS22MdZQk77KujhtlfK+38=
=9MxS
-----END PGP SIGNATURE-----




Changed Bug submitter from Paul Wise <pabs3@bonedaddy.net> to Paul Wise <pabs@debian.org>. Request was from Paul Wise <pabs@debian.org> to control@bugs.debian.org. Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Tue, 19 Jun 2007 00:39:46 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 17 21:46:41 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.